function J =objectivefunctionC(search_scalar,models,inputs,p_g,grad_g,n,analysis_type,sub_analysis_type);

%recover active model.
m=models.active;

%recover some parameters
optscal=m.parameters.optscal(n);
fit=m.parameters.fit(n);
control_type=m.parameters.control_type;
analysis_type=m.parameters.analysis_type;

%Update along gradient using scalar supplied by fmincon optimization routine
parameter=p_g+search_scalar*optscal*grad_g;

%Plug parameter into inputs
inputs=add(inputs,m.parameters.control_type,parameter,'doublevec',1,m.parameters.numberofnodes);

%Run diagnostic with updated parameters.
u_g=diagnostic_core_nonlinear(m,inputs,analysis_type,sub_analysis_type);

%add velocity to inputs.
inputs=add(inputs,'velocity',u_g,'doublevec',m.parameters.numberofdofspernode,m.parameters.numberofnodes);

%Compute misfit for this velocity field. 
J=CostFunction(m.elements,m.nodes,m.loads,m.materials,m.parameters,inputs,analysis_type,sub_analysis_type);
